# Discogs music scraper
#
# Copyright  1999-2009 Readerware Corporation.  All Rights Reserved.

import  os
import  string

from    com.readerware.http import HTTPConnection

from    scrapers.scrapers import searchFor
from    scrapers.scrapers import searchForPlus
from    scrapers.scrapers import stripText
from    scrapers.scrapers import convertArtist
from    jarray import zeros, array
from    java.lang import String


def extract():
    global title,artist,label,composer,date,copyDate,running,artistLF
    global value,valueDate,copies,upc,isbn,lccn,dewey,userNumber
    global format,series,sound,rating,condition,category
    global location,keywords,played,pflag,eflag,comments
    global dateEntered,dataSource,cart,ordered
    global diskCount,artistURL,conductor
    global trackTitles,trackArtists,trackWriters,trackTimes
    global user1,user2,user3,user4,user5,user6,user7,user8,user9,user10
    global usedprice,usedcount,collectibleprice,collectiblecount
    global newprice,newcount,listprice,salesrank,available
    global buyerwaiting,editionNumber,image,fullDateFormat,source


    # Defaults
    pflag               = "Y"
    eflag               = "Y"
    ordered             = "N"
    sound               = "Stereo"
    format              = "CD"
    usedprice           = ""
    usedcount           = ""
    collectibleprice    = ""
    collectiblecount    = ""
    newprice            = ""
    newcount            = ""
    listprice           = ""
    salesrank           = ""
    available           = "Y"
    buyerwaiting        = "N"
    artistLF            = ""


    # Find marketplace pricing
    marketinfo = source


    # Find Buyer Waiting
    i = string.find(marketinfo, "&nbsp;members&nbsp;want&nbsp;this")

    if i != -1:
        buyerwaiting = stripText(marketinfo[i-10:])
        buyerwaiting = searchForPlus(buyerwaiting, ">")
        i = string.find(buyerwaiting, "&")
        buyerwaiting = stripText(buyerwaiting[0:i])

        if buyerwaiting == "0":
            buyerwaiting = "N"
        else:
            buyerwaiting = "Y"


    # Main Extraction
    source = searchForPlus(source, "class=\"body\"")


    # Find Image
    imageTag = "class=\"image\""
    i = string.find(source, imageTag)

    if i != -1:
        source = searchForPlus(source, "class=\"image\"")
        i = string.find(source, " src=\"")

        if i != -1:
            source = searchForPlus(source, " src=\"")
            i = string.find(source, "\"")
            image = stripText(source[0:i])

            i = string.find(image, "music-no-image")

            if i != -1:
                image = ""


    # Find Artist
    i = string.find(source, "\"/artist/")

    if i != -1 and i < 250:
        source = searchForPlus(source, "\"/artist/")
        source = searchForPlus(source, ">")
        i = string.find(source, "<")
        artist = stripText(source[0:i])
        artist = string.replace(artist, "\xC3\x82", "")
        artist = convertArtist(artist)


    # Find Title
    source = searchForPlus(source, "- ")
    i = string.find(source, "<")
    title = stripText(source[0:i])


    # Find Label
    i = string.find(source, ">Label:")

    if i != -1:
        label = searchForPlus(source, ">Label:")
        label = searchForPlus(label, "class=\"content\"")
        label = searchForPlus(label, "\">")
        i = string.find(label, "<")
        label = stripText(label[0:i])


    # Find Format
    i = string.find(source, ">Format:<")

    if i != -1:
        format = searchForPlus(source, ">Format:<")
        format = searchForPlus(format, "class=\"content\"")
        format = searchForPlus(format, ">")
        i = string.find(format, "<")
        format = stripText(format[0:i])
        format = string.replace(format, "\xE2\x85\x93", "1/3")


    # Find Date
    tag = ">Year:"
    i = string.find(source, tag)

    if i == -1:
        tag = ">Released:"
        i = string.find(source, tag)

    if i != -1:
        date = searchForPlus(source, tag)
        date = searchForPlus(date, "class=\"content\"")
        date = searchForPlus(date, ">")
        i = string.find(date, "<")
        date = stripText(date[0:i])

        if fullDateFormat == "false":
            i = string.rfind(date, " ")

            if i != -1:
                date = stripText(date[i+1:])


    # Find Category
    i = string.find(source, ">Genre:<")

    if i != -1:
        category = searchForPlus(source, ">Genre:<")
        category = searchForPlus(category, "class=\"content\"")
        category = searchForPlus(category, ">")
        i = string.find(category, "<")
        category = stripText(category[0:i])
        category = string.replace(category, "\n", "")
        category = string.replace(category, "  ", " ")
        category = string.replace(category, "  ", " ")
        category = string.replace(category, "  ", " ")
        category = string.replace(category, "  ", " ")


    # Find Keywords
    i = string.find(source, ">Style:<")

    if i != -1:
        keywords = searchForPlus(source, ">Style:<")
        keywords = searchForPlus(keywords, "class=\"content\"")
        keywords = searchForPlus(keywords, ">")
        i = string.find(keywords, "<")
        keywords = stripText(keywords[0:i])

        while (searchFor(keywords, "\n") != None):
            keywords = string.replace(keywords, "\n", " ")

        while (searchFor(keywords, "  ") != None):
            keywords = string.replace(keywords, "  ", " ")


    # Find Comments
    comments = ""
    i = string.find(source, ">Notes<")

    if i != -1:
        comments = searchForPlus(source, ">Notes<")
        comments = searchForPlus(comments, "class=\"section_content\"")
        comments = searchForPlus(comments, ">")
        i = string.find(comments, "</div></div>")
        comments = stripText(comments[0:i])
        comments = string.replace(comments, "\n", "")
        comments = string.replace(comments, "<br>", "\n")
        comments = string.replace(comments, "\xE2\x84\x97", "(P)")
        comments = string.replace(comments, "\xC2\xA9", "")

        while (searchFor(comments, "<a ") != None):
            i = string.find(comments, "<a ")
            j = string.find(comments[i:], ">")
            comments = comments[0:i] + comments[i+j+1:]


    # Find Comments
    i = string.find(source, ">Credits<")

    if i != -1:
        comment = searchForPlus(source, ">Credits<")
        comment = searchForPlus(comment, "class=\"section_content\"")
        comment = searchForPlus(comment, ">")
        i = string.find(comment, "</div>")
        comment = stripText(comment[0:i])
        comment = string.replace(comment, "\n", "")
        comment = string.replace(comment, "<br>", "\n")
        comment = string.replace(comment, "<br />", "\n")
        comment = string.replace(comment, "\xE2\x84\x97", "(P)")
        comment = string.replace(comment, "\xC2\xA9", "")
        comment = string.replace(comment, "</span>", "")
        comment = string.replace(comment, "</a>", "")

        while (searchFor(comment, "<a ") != None):
            i = string.find(comment, "<a ")
            j = string.find(comment[i:], ">")
            comment = comment[0:i] + comment[i+j+1:]

        while (searchFor(comment, "<span") != None):
            i = string.find(comment, "<span")
            j = string.find(comment[i:], ">")
            comment = comment[0:i] + comment[i+j+1:]

        while (searchFor(comment, "  ") != None):
            comment = string.replace(comment, "  ", " ")

        while (searchFor(comment, " ,") != None):
            comment = string.replace(comment, " ,", ",")

        while (searchFor(comment, "\n ") != None):
            comment = string.replace(comment, "\n ", "\n")

        comment = "Credits\n\n" + comment

        if comments == "":
            comments = comment
        else:
            comments = comments + "\n\n" + comment


    # Find Tracks
    i = string.find(source, ">Tracklist<")

    if i != -1:
        source = searchForPlus(source, ">Tracklist<")
        i = string.find(source, "</table>")
        disks = stripText(source[0:i])

        if string.find(disks, ">Disc: ") == -1:
            disks = ">Disc: 1<" + disks

        trackList = []
        artistList = []
        timeList = []
        diskCount = 0

        while (searchFor(disks, ">Disc: ") != None):
            diskCount = diskCount + 1
            disks = searchForPlus(disks, ">Disc: ")
            i = string.find(disks, "<")
            diskid = "%02d" % stripText(disks[0:i])

            i = string.find(disks, "</table>")
            tracks = stripText(disks[0:i])
            trackIndex = 1

            while (searchFor(tracks, "class=\"track_title\"") != None):
                tracks = searchForPlus(tracks, "class=\"track_title\"")
                tracks = searchForPlus(tracks, ">")
                i = string.find(tracks, "<")
                trackid = "%02d" % trackIndex
                track = stripText(tracks[0:i])
                time = ""
                tartist = ""

                i = string.rfind(tracks, "class=\"track_duration\"")
                
                if i != -1:
                    tracks = searchForPlus(tracks, "class=\"track_duration\"")
                    tracks = searchForPlus(tracks, ">")
                    i = string.find(tracks, "<")
                    time = stripText(tracks[0:i])
                        

                trackList.append(diskid + "-" + trackid + "-" + track)

                if tartist != "":
                    artistList.append(diskid + "-" + trackid + "-" + tartist)
                else:
                    artistList.append(diskid + "-" + trackid + "-")

                if time != "":
                    timeList.append(diskid + "-" + trackid + "-" + time)
                else:
                    timeList.append(diskid + "-" + trackid + "-")

                trackIndex = trackIndex + 1
                tracks = tracks[i+1:]

        trackList.sort()
        trackTitles = array(trackList, String)
        artistList.sort()
        trackArtists = array(artistList, String)
        timeList.sort()
        trackTimes = array(timeList, String)




    # Find user rating
    i = string.find(source, ">Average Customer Review:<")

    if i != -1:
        temp = searchForPlus(source, ">Average Customer Review:<")
        temp = searchForPlus(temp, "<img src=\"")
        i = string.find(temp, "\"")
        temp = stripText(temp[0:i])
        i = string.rfind(temp, "/")

        if i != -1:
            temp = stripText(temp[i+1:])

        i = string.find(temp, ".")

        if i != -1:
            temp = stripText(temp[0:i])

        if temp.startswith("stars-") == 1:
            temp = searchForPlus(temp, "stars-")

        temp = string.replace(temp, "-", ".")

        if temp != "":
            rating = temp + " Stars"





# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*



try:
    extract()
finally:
    if os.path.exists("scrapers/awuserexit.py"):
        execfile("scrapers/awuserexit.py") in globals()
