# Books-A-Million scraper
#
# Copyright  1999-2009 Readerware Corporation.  All Rights Reserved.

import  os
import  string

from    scrapers.scrapers import searchFor
from    scrapers.scrapers import searchForPlus
from    scrapers.scrapers import stripText


def extract():
    global title,author,isbn,publisher,format,first,signed,date,place
    global copies,rating,condition,category,read,pflag,eflag,value
    global comments,dateEntered,dataSource,cart,ordered
    global lccn,dewey,userNumber,copyDate,valueDate,location
    global series,pages,keywords,dimensions
    global user1,user2,user3,user4,user5,user6,user7,user8,user9,user10
    global author2,author3,author4,author5,author6
    global usedprice,usedcount,collectibleprice,collectiblecount
    global newprice,newcount,listprice,readinglevel,salesrank,available
    global buyerwaiting,editionNumber,weight,image
    global fullDateFormat,source


    # Defaults
    first               = "N"
    signed              = "N"
    read                = "N"
    pflag               = "Y"
    eflag               = "Y"
    ordered             = "N"
    usedprice           = ""
    usedcount           = ""
    collectibleprice    = ""
    collectiblecount    = ""
    newprice            = ""
    newcount            = ""
    listprice           = ""
    readinglevel        = ""
    salesrank           = ""
    available           = "Y"
    buyerwaiting        = "N"
    weight              = ""

    # No place extraction default to US
    # place = "United States"


    # Find optional fields, pricing info etc.
    marketinfo = source

    # Find List price
    i = string.find(marketinfo, ">Retail Price:")

    if (i != -1):
        listprice = searchForPlus(marketinfo, ">Retail Price:")
        listprice = searchForPlus(listprice, ">")
        i = string.find(listprice, "<")
        listprice = stripText(listprice[0:i])


    # Find Reading level
    i = string.find(marketinfo, ">Reading Level:")

    if (i != -1):
        readinglevel = searchForPlus(marketinfo, ">Reading Level:")
        readinglevel = searchForPlus(readinglevel, ">")
        i = string.find(readinglevel, "<")
        readinglevel = stripText(readinglevel[0:i])


    # Main extraction
    # Find Book details
    source = searchForPlus(source, "class=\"module details\"")


    # Find Title
    source = searchForPlus(source, "<h2>")
    i = string.find(source, "<")
    title = stripText(source[0:i])


    # Find Format
    source = searchForPlus(source, "\">")
    source = searchForPlus(source, "(")
    i = string.find(source, ")")
    format = stripText(source[0:i])


    # Find Author
    source = searchFor(source, "&type=author&query=")
    i = string.find(source, "\n")
    authors = stripText(source[0:i])
    print "AT",authors
    authorList = []

    while (searchFor(authors, "&type=author&query=") != None):
        authors = searchForPlus(authors, "&type=author&query=")
        authors = searchForPlus(authors, "\">")
        i = string.find(authors, "<")
        author = stripText(authors[0:i])

        author = string.replace(author, "%26", "&")

        i = string.rfind(author, " ")

        if i != -1:
            author = stripText(author[i:]) + ", " + stripText(author[0:i])

        authorList.append(author)


    if len(authorList) > 0:
        author = authorList[0]

    if len(authorList) > 1:
        author2 = authorList[1]

    if len(authorList) > 2:
        author3 = authorList[2]

    if len(authorList) > 3:
        author4 = authorList[3]

    if len(authorList) > 4:
        author5 = authorList[4]

    if len(authorList) > 5:
        author6 = authorList[5]

    # Find Image
    i = string.find(source, "<div class=\"dropshadow2\">")

    if i != -1:
        source = searchForPlus(source, "<div class=\"dropshadow2\">")
        i = string.find(source, "</div>")
        image = stripText(source[0:i])
        image = searchForPlus(image, "src=\"")
        i = string.find(image, "\"")
        image = stripText(image[0:i])


    # Find Price
    source = searchForPlus(source, ">Online Price:")
    i = string.find(source, "<")
    value = stripText(source[0:i])


    # Find Comments
    i = string.find(source, ">Overview<")

    if i != -1:
        source = searchForPlus(source, ">Overview<")
        source = searchForPlus(source, "<p>")
        i = string.find(source, "</p>")
        comments = stripText(source[0:i])

        while (searchFor(comments, "</TABLE>") != None):
            comments = searchForPlus(comments, "</TABLE>")

        comments = string.replace(comments, "", "'")
        comments = string.replace(comments, "<p>", "")
        comments = string.replace(comments, "<P>", "")
        comments = string.replace(comments, "<hr>", "\n\n")
        comments = string.replace(comments, "<b>", "")
        comments = string.replace(comments, "</b>", "")
        comments = string.replace(comments, "<I>", "")
        comments = string.replace(comments, "</I>", "")
        comments = string.replace(comments, "<i>", "")
        comments = string.replace(comments, "</i>", "")
        comments = string.replace(comments, "</font>", "")
        comments = string.replace(comments, "</FONT>", "")
        comments = string.replace(comments, "</A>", "")
        comments = string.replace(comments, "</TD>", "")
        comments = string.replace(comments, "<BR>", "\n")
        comments = string.replace(comments, "Read the first chapter now! ", "")

        while (searchFor(comments, "<a ") != None):
            i = string.find(comments, "<a ")
            j = string.find(comments[i:], "\">")
            comments = comments[0:i] + comments[i+j+2:]

        while (searchFor(comments, "<A ") != None):
            i = string.find(comments, "<A ")
            j = string.find(comments[i:], "\">")
            comments = comments[0:i] + comments[i+j+2:]

        while (searchFor(comments, "<font ") != None):
            i = string.find(comments, "<font ")
            j = string.find(comments[i:], "\">")
            comments = comments[0:i] + comments[i+j+2:]

        comments = stripText(comments)


    # Find category
    i = string.find(source, ">Related Categories:<")

    if (i != -1):
        category = ""
        source = searchForPlus(source, ">Related Categories:<")
        source = searchForPlus(source, "<a href=")
        source = searchForPlus(source, "<a href=")
        source = searchForPlus(source, ">")
        i = string.find(source, "<")

        if (i != -1):
            category = category +  stripText(source[0:i]) + " > "

        source = searchForPlus(source, "<a href=")
        source = searchForPlus(source, ">")
        i = string.find(source, "<")

        if (i != -1):
            category = category + stripText(source[0:i])


    # Find ISBN
    source = searchForPlus(source, ">ISBN-10<")
    source = searchForPlus(source, ":")
    i = string.find(source, "<")
    isbn = stripText(source[0:i])

    if (isbn[len(isbn)-1:] == "/"):
        isbn = isbn[0:len(isbn)-2]


    # Find Publisher
    source = searchForPlus(source, ">Publisher<")
    source = searchForPlus(source, ":")
    i = string.find(source, "<")
    publisher = stripText(source[0:i])

    if (publisher[len(publisher)-1:] == "/"):
        publisher = publisher[0:len(publisher)-2]


    # Find Publication Date
    source = searchForPlus(source, ">Date<")
    source = searchForPlus(source, ":")
    i = string.find(source, "<")
    date = stripText(source[0:i])

    if (date[len(date)-1:] == "/"):
        date = date[0:len(date)-2]

    if fullDateFormat == "false":
        i = string.rfind(date, " ")

        if i != -1:
            date = stripText(date[i+1:])


    # Find Pages
    i = string.find(source, ">Page Count<")

    if i != -1:
        source = searchForPlus(source, ">Page Count<")
        source = searchForPlus(source, ":")
        i = string.find(source, "<")
        pages = stripText(source[0:i])


try:
    extract()
finally:
    if os.path.exists("scrapers/userexit.py"):
        execfile("scrapers/userexit.py") in globals()
