# bol.it scraper
#
# copied from various sources
#

import  os
import  string

from    com.readerware.http import HTTPConnection

from    scrapers.scrapers import calcISBN10CheckDigit
from    scrapers.scrapers import calcISBN13CheckDigit
from    scrapers.scrapers import convertAuthor
from    scrapers.scrapers import searchFor
from    scrapers.scrapers import searchForPlus
from    scrapers.scrapers import stripText
from    scrapers.scrapers import stripHTML
from    scrapers.scrapers import stripNewLines

# remove any <a> tags, keeping everything else
# assume <a href="xxx">yyy</a>
def removeAtags(str):

    cat = ""
    while (str != None):
        # save anything before
        tag = "<a"
        i = string.find(str, tag)
        if i == -1:
            tag = "<A"
            i = string.find(str, tag)
        if i == -1:
            cat = cat + str
            return cat
        else:
            if i > 0:
                cat = cat + str[:i]
                str = searchForPlus(str, tag)

        # move marker to "inside"
        tag = ">"
        i = string.find(str, tag)
        if i == -1:
            return cat
        else:
            str = searchForPlus(str, tag)

        tag = "</a>"
        i = string.find(str, tag)
        if i == -1:
            tag = "</A>"
            i = string.find(str, tag)
        if i == -1:
            return cat
        else:
            cat = cat + str[:i]
            str = searchForPlus(str, tag)


def extract():
    global title,author,isbn,publisher,format,first,signed,date,place
    global copies,rating,condition,category,read,pflag,eflag,value
    global comments,dateEntered,dataSource,cart,ordered
    global lccn,dewey,userNumber,copyDate,valueDate,location
    global series,pages,keywords,dimensions
    global user1,user2,user3,user4,user5,user6,user7,user8,user9,user10
    global author2,author3,author4,author5,author6
    global usedprice,usedcount,collectibleprice,collectiblecount
    global newprice,newcount,listprice,readinglevel,salesrank,available
    global buyerwaiting,editionNumber,weight,image
    global fullDateFormat,source


    # Defaults
    first               = "N"
    signed              = "N"
    read                = "N"
    pflag               = "Y"
    eflag               = "Y"
    ordered             = "N"
    usedprice           = ""
    usedcount           = ""
    collectibleprice    = ""
    collectiblecount    = ""
    newprice            = ""
    newcount            = ""
    listprice           = ""
    readinglevel        = ""
    salesrank           = ""
    available           = "Y"
    buyerwaiting        = "N"
    weight              = ""


    # No place extraction default to US
    # place = "Italia"


   
    # is this the search page or the detail page?
    i = string.find (source, "ERROR - URL:")

    if i != -1: 
        source = searchForPlus(source, "ERROR - URL:")
        i = string.find(source, "/ea")
        url = stripText(source[0:i+3])
        source = searchForPlus(source, "/ea")
        i = string.find(source, ".")
        ean = "978" + stripText(source[0:i-1])

        http = HTTPConnection()
        http.resetReferer();
        http.blockForLoad();
        source = http.getContents(url + ean + ".html")
        t2 = open("trace2.html", "w")
        t2.write(source)
        t2.close()

    uri = "http://www.bol.it"


    # Find Cover Image
    tag = "class=\"bol_cover\""
    i = string.find(source, tag)

    if i != -1:
        source = searchForPlus(source, tag)
        source = searchForPlus(source, "img src=\"")
        i = string.find(source, "\"")
        image = stripText(source[0:i])

        if (image[0] == "/"):
            image = uri + image;
 

    # Find Title
    tag = "<!-- RIEPILOGO DATI PRODOTTO-->"
    source = searchForPlus(source, tag)
    source = searchForPlus(source, "<h1>")
    i = string.find(source, "</h1>");
    title = stripText(source[0:i])
    source = stripText(source[i:])

    # Find Author
    # author is in an href tag, comma separated authors
    authorList = []

    i = string.find(source, "?tpr=")

    if i != -1:
        authors = searchForPlus(source, "?tpr=")
        authors = searchForPlus(authors, ">")
        i = string.find(authors, "<")
        authors = stripText(authors[0:i])

        while (authors != None):
            i = string.find(authors, ",")

            if i == -1:
                authorList.append(convertAuthor(authors))
                authors = None
            else:
                authorList.append(convertAuthor(authors[0:i]))
                authors = stripText(authors[i+1:])                

        if len(authorList) > 0:
            author = authorList[0]

        if len(authorList) > 1:
            author2 = authorList[1]

        if len(authorList) > 2:
            author3 = authorList[2]

        if len(authorList) > 3:
            author4 = authorList[3]

        if len(authorList) > 4:
            author5 = authorList[4]

        if len(authorList) > 5:
            author6 = authorList[5]

    if title != "" and len(authorList) == 0:
        author = "No Author"


    # Find List price
    i = string.find(source, "Prezzo di copertina:")

    if i != -1:
        listprice = searchForPlus(source, "Prezzo di copertina:")
        listprice = searchFor(listprice, "&euro;")
        i = string.find(listprice, "<")
        listprice = stripText(listprice[0:i])


    # Find Price
    i = string.find(source, "Prezzo di copertina:")

    if i != -1:
        value = searchForPlus(source, "Prezzo di copertina:")
        value = searchFor(value, "&euro;")
        i = string.find(value, "<")
        value = stripText(value[0:i])

        i = string.find(source, "class=\"bol_price\"")

        if i != -1:
            value = searchForPlus(source, "class=\"bol_price\"")
            value = searchFor(value, "&euro;")
            i = string.find(value, "<")
            value = stripText(value[0:i])


    # Find Comments
    i = string.find(source, "id=\"contenuto_scheda\"")

    if i != -1:
        comments = searchForPlus(source, "id=\"contenuto_scheda\"")
        comments = searchForPlus(comments, "<h2")
        comments = searchForPlus(comments, "\">")
        i = string.find(comments, "</div>")
        comments = stripText(comments[0:i])

        while (searchFor(comments, "\n") != None):
            comments = string.replace(comments, "\n", " ")

        comments = string.replace(comments, "</h2>", "")
        comments = string.replace(comments, "</p>", "")

        while (searchFor(comments, "<p ") != None):
            i = string.find(comments, "<p ")
            j = string.find(comments[i:], ">")

            if j == -1:
                break;

            comments = stripText(comments[0:i]) + "\n" + stripText(comments[i+j+1:])

        while (searchFor(comments, "  ") != None):
            i = string.find(comments, "  ")
            comments = comments[0:i] + comments[i+1:]


    # Find Format
    i = string.find(source, ">Formato:<")

    if i != -1:
        format = searchForPlus(source, ">Formato:<")
        format = searchForPlus(format, ">")
        i = string.find(format, "<")
        format = stripText(format[0:i])


    # Find pages
    i = string.find(source, ">Pagine:<")

    if i != -1:
        pages = searchForPlus(source, ">Pagine:<")
        pages = searchForPlus(pages, ">")
        i = string.find(pages, "<")
        pages = stripText(pages[0:i])


    # Find publisher
    i = string.find(source, ">Editore:<")

    if i != -1:
        publisher = searchForPlus(source, ">Editore:<")
        publisher = searchForPlus(publisher, ">")
        i = string.find(publisher, "<")
        publisher = stripText(publisher[0:i])


    # Find publication date
    i = string.find(source, ">Anno di pubblicazione<")

    if i != -1:
        date = searchForPlus(source, ">Anno di pubblicazione<")
        date = searchForPlus(date, ">")
        i = string.find(date, "<")
        date = stripText(date[0:i])


    # Find ISBN
    i = string.find(source, ">Codice EAN:<")

    if i != -1:
        isbn = searchForPlus(source, ">Codice EAN:<")
        isbn = searchForPlus(isbn, ">")
        i = string.find(isbn, "<")
        isbn = stripText(isbn[0:i])

        if isbn.startswith("978") == 1:
            isbn = stripText(isbn[3:])

            if len(isbn) > 9:
                isbn = stripText(isbn[0:9])

            isbn = calcISBN10CheckDigit(isbn)


    # Find Category
    i = string.find(source, ">Generi:<")

    if i != -1:
        category = ""
        categories = searchForPlus(source, ">Generi:<")
        i = string.find(categories, "</p>")
        categories = stripText(categories[0:i])

        while (string.find(categories, "class=\"bol_blue\"") != -1):
            categories = searchForPlus(categories, "class=\"bol_blue\"")
            categories = searchForPlus(categories, ">")
            i = string.find(categories, "<")

            if category != "":
                category = category + " : "

            category = category + stripText(categories[0:i])

try:
    extract()
finally:
    if os.path.exists("scrapers/userexit.py"):
        execfile("scrapers/userexit.py") in globals()
