# Blackwell [UK] scraper
#
# Copyright  1999-2008 Readerware Corporation.  All Rights Reserved.

import  os
import  string

from    scrapers.scrapers import calcISBN10CheckDigit
from    scrapers.scrapers import convertAuthor
from    scrapers.scrapers import searchFor
from    scrapers.scrapers import searchForPlus
from    scrapers.scrapers import stripText
from    scrapers.scrapers import stripHTML


def extract():
    global title,author,isbn,publisher,format,first,signed,date,place
    global copies,rating,condition,category,read,pflag,eflag,value
    global comments,dateEntered,dataSource,cart,ordered
    global lccn,dewey,userNumber,copyDate,valueDate,location
    global series,pages,keywords,dimensions
    global user1,user2,user3,user4,user5,user6,user7,user8,user9,user10
    global author2,author3,author4,author5,author6
    global usedprice,usedcount,collectibleprice,collectiblecount
    global newprice,newcount,listprice,readinglevel,salesrank,available
    global buyerwaiting,editionNumber,weight,image
    global fullDateFormat,source


    # Defaults
    first               = "N"
    signed              = "N"
    read                = "N"
    pflag               = "Y"
    eflag               = "Y"
    ordered             = "N"
    usedprice           = ""
    usedcount           = ""
    collectibleprice    = ""
    collectiblecount    = ""
    newprice            = ""
    newcount            = ""
    listprice           = ""
    readinglevel        = ""
    salesrank           = ""
    available           = "Y"
    buyerwaiting        = "N"
    weight              = ""

    # No place extraction default to UK
    # place = "United Kingdom"




    # Main extraction
    source = searchForPlus(source, "class=\"content\"")


    # Find Image
    i = string.find(source, "class=\"left image\"")

    if i != -1:
        source = searchForPlus(source, "class=\"left image\"")
        source = searchForPlus(source, "src=\"")
        i = string.find(source, "\"")
        image = "http://bookshop.blackwell.co.uk" + stripText(source[0:i])
        image = string.replace(image, "/DI420", "")


    # Find Title
    source = searchForPlus(source, "<h1>")
    i = string.find(source, "<")
    title = stripHTML(source[0:i])


    # Find Author
    i = string.find(source, "?author=")

    if i != -1:
        authorList = []
        source = searchFor(source, "?author=")
        i = string.find(source, "</p>")
        authors = stripText(source[0:i])
        authorList = []

        while (searchFor(authors, "?author=") != None):
            authors = searchForPlus(authors, "?author=")
            authors = searchForPlus(authors, ">")
            i = string.find(authors, "<")
            author = stripText(authors[0:i])
            i = string.rfind(author, " ")

            if (i != -1):
                author = stripText(author[i:]) + ", " + stripText(author[0:i])

            authorList.append(author)


        if len(authorList) > 0:
            author = authorList[0]

        if len(authorList) > 1:
            author2 = authorList[1]

        if len(authorList) > 2:
            author3 = authorList[2]

        if len(authorList) > 3:
            author4 = authorList[3]

        if len(authorList) > 4:
            author5 = authorList[4]

        if len(authorList) > 5:
            author6 = authorList[5]

    if title != "" and len(authorList) == 0:
        author = "No Author"


    # Find ISBN
    i = string.find(source, ">ISBN:<")

    if i != -1:
        isbn = searchForPlus(source, ">ISBN:<")
        isbn = searchForPlus(isbn, ">")
        i = string.find(isbn, "<")
        isbn = stripHTML(isbn[0:i])

        if isbn.startswith("978") == 1:
            isbn = isbn[3:]
            isbn = stripText(isbn[0:len(isbn)-1])
            isbn = calcISBN10CheckDigit(isbn)


    # Find Format
    i = string.find(source, ">Format:<")

    if i != -1:
        format = searchForPlus(source, ">Format:<")
        format = searchForPlus(format, ">")
        i = string.find(format, "<")
        format = stripHTML(format[0:i])


    # Find Publisher
    i = string.find(source, ">Publisher:<")

    if i != -1:
        publisher = searchForPlus(source, ">Publisher:<")
        publisher = searchForPlus(publisher, "\">")
        i = string.find(publisher, "<")
        publisher = stripHTML(publisher[0:i])


    # Find Price
    i = string.find(source, ">Pricing Details<")

    if i != -1:
        value = searchForPlus(source, ">Pricing Details<")
        value = searchForPlus(value, "&pound;")
        i = string.find(value, "<")
        value = "" + stripHTML(value[0:i])


    # Find Comments
    i = string.find(source, "id=\"biblio_0\"")

    if i != -1:
        comments = searchForPlus(source, "id=\"biblio_0\"")
        comments = searchForPlus(comments, "class=\"content\"")
        comments = searchForPlus(comments, "\">")
        i = string.find(comments, "</div>")
        comments = stripHTML(comments[0:i])

        if comments.startswith("<a name=\"Book details\">") == 1:
            comments = ""

        comments = string.replace(comments, "</p>", "")


    # Find ISBN
    i = string.find(source, ">ISBN<")

    if i != -1:
        isbn = searchForPlus(source, ">ISBN<")
        isbn = searchForPlus(isbn, "\">")
        i = string.find(isbn, "<")
        isbn = stripHTML(isbn[0:i])

        if isbn.startswith("978") == 1:
            isbn = isbn[3:]
            isbn = stripText(isbn[0:len(isbn)-1])
            isbn = calcISBN10CheckDigit(isbn)


    # Find Pages
    i = string.find(source, ">Pages<")

    if i != -1:
        pages = searchForPlus(source, ">Pages<")
        pages = searchForPlus(pages, "\">")
        i = string.find(pages, "<")
        pages = stripHTML(pages[0:i])


    # Find Format
    i = string.find(source, ">Format<")

    if i != -1:
        format = searchForPlus(source, ">Format<")
        format = searchForPlus(format, "\">")
        i = string.find(format, "<")
        format = stripHTML(format[0:i])


    # Find Publisher
    i = string.find(source, ">Publisher<")

    if i != -1:
        publisher = searchForPlus(source, ">Publisher<")
        publisher = searchForPlus(publisher, "\">")
        i = string.find(publisher, "<")
        publisher = stripHTML(publisher[0:i])


    # Find Place
    i = string.find(source, ">Published in<")

    if i != -1:
        place = searchForPlus(source, ">Published in<")
        place = searchForPlus(place, "\">")
        i = string.find(place, "<")
        place = stripHTML(place[0:i])


    # Find Dimensions
    i = string.find(source, ">Height (mm)<")

    if i != -1:
        height = searchForPlus(source, ">Height (mm)<")
        height = searchForPlus(height, "\">")
        i = string.find(height, "<")
        height = stripHTML(height[0:i])

        i = string.find(source, ">Width (mm)<")

        if i != -1:
            width = searchForPlus(source, ">Width (mm)<")
            width = searchForPlus(width, "\">")
            i = string.find(width, "<")
            width = stripHTML(width[0:i])

            dimensions = height + " / " + width


    # Find Publication date
    i = string.find(source, ">Publication date<")

    if i != -1:
        date = searchForPlus(source, ">Publication date<")
        date = searchForPlus(date, "\">")
        i = string.find(date, "<")
        date = stripHTML(date[0:i])

        if fullDateFormat == "false":
            i = string.rfind(date, " ")

            if i != -1:
                date = stripText(date[i+1:])


    # Find Dewey Decimal Number
    i = string.find(source, ">DEWEY<")

    if i != -1:
        dewey = searchForPlus(source, ">DEWEY<")
        dewey = searchForPlus(dewey, "\">")
        i = string.find(dewey, "<")
        dewey = stripHTML(dewey[0:i])


    # Find Reading level
    i = string.find(source, ">Academic level<")

    if i != -1:
        readinglevel = searchForPlus(source, ">Academic level<")
        readinglevel = searchForPlus(readinglevel, "\">")
        i = string.find(readinglevel, "<")
        readinglevel = stripHTML(readinglevel[0:i])




try:
    extract()
finally:
    if os.path.exists("scrapers/userexit.py"):
        execfile("scrapers/userexit.py") in globals()
