# Library and Archives Canada scraper
#
# Copyright  1999-2009 Readerware Corporation.  All Rights Reserved.

import  os
import  string

from    com.readerware.http import HTTPConnection

from    scrapers.scrapers import convertAuthor
from    scrapers.scrapers import searchFor
from    scrapers.scrapers import searchForPlus
from    scrapers.scrapers import stripText
from    scrapers.scrapers import stripHTML
from    scrapers.scrapers import stripNewLines


def extract():
    global title,author,isbn,publisher,format,first,signed,date,place
    global copies,rating,condition,category,read,pflag,eflag,value
    global comments,dateEntered,dataSource,cart,ordered
    global lccn,dewey,userNumber,copyDate,valueDate,location
    global series,pages,keywords,dimensions
    global user1,user2,user3,user4,user5,user6,user7,user8,user9,user10
    global author2,author3,author4,author5,author6
    global usedprice,usedcount,collectibleprice,collectiblecount
    global newprice,newcount,listprice,readinglevel,salesrank,available
    global buyerwaiting,editionNumber,weight,image
    global fullDateFormat,source
    global callnumber


    # Defaults
    first               = "N"
    signed              = "N"
    read                = "N"
    pflag               = "Y"
    eflag               = "Y"
    ordered             = "N"
    usedprice           = ""
    usedcount           = ""
    collectibleprice    = ""
    collectiblecount    = ""
    newprice            = ""
    newcount            = ""
    listprice           = ""
    readinglevel        = ""
    salesrank           = ""
    available           = "Y"
    buyerwaiting        = "N"
    weight              = ""


    # No place extraction default to US
    # place = "United States"


    i = string.find(source, ">Library Search Result")

    if i != -1:
        # Search results page, get detail page
        source = searchForPlus(source, ">Library Search Result")
        source = searchForPlus(source, ">&nbsp;1.&nbsp;<")
        source = searchForPlus(source, "href=\"")
        i = string.find(source, "\"")
        source = stripText(source[0:i])
        source = string.replace(source, "&amp;", "&")
        http = HTTPConnection()
        http.resetReferer();
        http.blockForLoad();
        source = http.getContents(source)
        t = open("trace2.html", "w")
        t.write(source)
        t.close()


    # Find optional fields, pricing info etc.
    marketinfo = source


    # Main extraction
    # Find Author
    authorList = []
    i = string.find(source, "NAME(S):")

    if i != -1:
        source = searchFor(source, "NAME(S):")
        i = string.find(source, "TITLE(S):")
        authors = stripText(source[0:i])

        while (searchFor(authors, "HREF=\"") != None):
            authors = searchForPlus(authors, "HREF=\"")
            authors = searchForPlus(authors, "\">")
            i = string.find(authors, "<")
            author = stripText(authors[0:i])
            i = string.rfind(author, "-")

            if i != -1:
                i = string.rfind(author, ",")
                author = stripText(author[0:i])

            authorList.append(author)


        if len(authorList) > 0:
            author = authorList[0]

        if len(authorList) > 1:
            author2 = authorList[1]

        if len(authorList) > 2:
            author3 = authorList[2]

        if len(authorList) > 3:
            author4 = authorList[3]

        if len(authorList) > 4:
            author5 = authorList[4]

        if len(authorList) > 5:
            author6 = authorList[5]


    # Find Title
    source = searchForPlus(source, "TITLE(S):")
    i = string.find(source, "\n")
    title = stripText(source[0:i])

    i = string.rfind(title, " / ")

    if i != -1:
        title = stripText(title[0:i])


    # Find Publisher
    i = string.find(source, "PUBLISHER:")

    if i != -1:
        publisher = searchForPlus(source, "PUBLISHER:")
        i = string.find(publisher, "\n")
        publisher = stripText(publisher[0:i])

        i = string.find(publisher, " : ")

        if i != -1:
            place = stripText(publisher[0:i])
            publisher = stripText(publisher[i+2:])

        i = string.find(publisher, ", c")

        if i != -1:
            copyDate = stripText(publisher[i+3:])
            publisher = stripText(publisher[0:i])

            i = string.find(copyDate, ".")

            if i != -1:
                copyDate = stripText(copyDate[0:i])


    # Find Comments, part 1
    comments = ""
    i = string.find(source, "DESCRIPTION:")

    if i != -1:
        comment = searchForPlus(source, "DESCRIPTION:")
        i = string.find(comment, "S:")
        comment = stripText(comment[0:i])

        i = string.find(comment, "N:")

        if i != -1:
            comment = stripText(comment[0:i])

        i = string.rfind(comment, " ")

        if i != -1:
            comment = stripText(comment[0:i])


        while (searchFor(comment, "  ") != None):
            comment = string.replace(comment, "  ", " ")


        while (searchFor(comment, "\n ") != None):
            comment = string.replace(comment, "\n ", "\n")
            
        comments = comment

        i = string.find(comment, " p.")
        
        if i != -1:
            pages = stripText(comment[0:i])
            i = string.rfind(pages, " ")

            if i != -1:
                pages = stripText(pages[i:])


    # Find Series
    i = string.find(source, "SERIES:")

    if i != -1:
        series = searchForPlus(source, "SERIES:")
        series = searchForPlus(source, "\">")
        i = string.find(series, "<")
        series = stripText(series[0:i])


    # Find Comments, part 2
    i = string.find(source, "NOTES:")

    if i != -1:
        comment = searchForPlus(source, "NOTES:")
        i = string.find(comment, "S:")
        comment = stripText(comment[0:i])

        i = string.find(comment, "N:")

        if i != -1:
            comment = stripText(comment[0:i])

        i = string.rfind(comment, " ")

        if i != -1:
            comment = stripText(comment[0:i])


        while (searchFor(comment, "  ") != None):
            comment = string.replace(comment, "  ", " ")


        while (searchFor(comment, "\n ") != None):
            comment = string.replace(comment, "\n ", "\n")
            
        if comments == "":
            comments = comment
        else:
            comments = comments + "\n\n" + comment


    # Find LCCN
    i = string.find(source, "LCCN:")

    if i != -1:
        lccn = searchForPlus(source, "LCCN:")
        i = string.find(lccn, "\n")
        lccn = stripText(lccn[0:i])


    # Find ISBN
    i = string.find(source, "ISBN:")

    if i != -1:
        isbn = searchForPlus(source, "ISBN:")
        i = string.find(isbn, "\n")
        isbn = stripText(isbn[0:i])

        i = string.find(isbn, " : ")

        if i != -1:
            value = stripText(isbn[i+2:])
            isbn = stripText(isbn[0:i])

        i = string.find(isbn, " (")

        if i != -1:
            isbn = stripText(isbn[0:i])


    # Find Call Number
    i = string.find(source, "LC Call no.:")

    if i != -1:
        callnumber = searchForPlus(source, "LC Call no.:")
        callnumber = searchForPlus(callnumber, "\">")
        i = string.find(callnumber, "<")
        callnumber = stripText(callnumber[0:i])


    # Find Dewey Decimal Number
    i = string.find(source, "Dewey:")

    if i != -1:
        dewey = searchForPlus(source, "Dewey:")
        dewey = searchForPlus(dewey, "\">")
        i = string.find(dewey, "<")
        dewey = stripText(dewey[0:i])


    # Find Keywords
    i = string.find(source, "SUBJECTS:")

    if i != -1:
        keywords = ""
        temp = searchForPlus(source, "SUBJECTS:")
        i = string.find(temp, "</PRE>")
        temp = stripText(temp[0:i])

        while (searchFor(temp, "HREF=\"") != None):
            temp = searchForPlus(temp, "HREF=\"")
            temp = searchForPlus(temp, "\">")
            i = string.find(temp, "<")
            keyword = stripText(temp[0:i])

            if keywords == "":
                keywords = keyword
                category = keyword
            else:
                keywords = keywords + ", " + keyword




try:
    extract()
finally:
    if os.path.exists("scrapers/userexit.py"):
        execfile("scrapers/userexit.py") in globals()
