# fishpond.com./au scraper
#
# Copyright  1999-2009 Readerware Corporation.  All Rights Reserved.

import  os
import  string

from    com.readerware.http import HTTPConnection

from    scrapers.scrapers import convertAuthor
from    scrapers.scrapers import searchFor
from    scrapers.scrapers import searchForPlus
from    scrapers.scrapers import stripText
from    scrapers.scrapers import stripHTML
from    scrapers.scrapers import stripNewLines


def extract():
    global title,author,isbn,publisher,format,first,signed,date,place
    global copies,rating,condition,category,read,pflag,eflag,value
    global comments,dateEntered,dataSource,cart,ordered
    global lccn,dewey,userNumber,copyDate,valueDate,location
    global series,pages,keywords,dimensions
    global user1,user2,user3,user4,user5,user6,user7,user8,user9,user10
    global author2,author3,author4,author5,author6
    global usedprice,usedcount,collectibleprice,collectiblecount
    global newprice,newcount,listprice,readinglevel,salesrank,available
    global buyerwaiting,editionNumber,weight,image
    global fullDateFormat,source


    # Defaults
    first               = "N"
    signed              = "N"
    read                = "N"
    pflag               = "Y"
    eflag               = "Y"
    ordered             = "N"
    usedprice           = ""
    usedcount           = ""
    collectibleprice    = ""
    collectiblecount    = ""
    newprice            = ""
    newcount            = ""
    listprice           = ""
    readinglevel        = ""
    salesrank           = ""
    available           = "Y"
    buyerwaiting        = "N"
    weight              = ""



    i = string.find(source, ">Search Results for ")

    if i != -1:
        source = searchForPlus(source, ">Search Results for ")
        source = searchForPlus(source, "class=\"productListing-data\"")
        source = searchForPlus(source, "href=\"")
        i = string.find(source, "\"")
        url = stripText(source[0:i])
        http = HTTPConnection()
        http.resetReferer();
        http.blockForLoad();
        source = http.getContents(url)
        t2 = open("trace2.html", "w")
        t2.write(source)
        t2.close()



    # Find optional fields, pricing info etc.
    marketinfo = source


    # Find List price
    i = string.find(marketinfo, "class=\"productOriginalPrice\"")

    if i != -1:
        listprice = searchForPlus(marketinfo, "class=\"productOriginalPrice\"")
        listprice = searchFor(listprice, "$")
        i = string.find(listprice, "<")
        listprice = stripText(listprice[0:i])


    # Main extraction
    # Find Category
    category = ""

    while (searchFor(source, "class=\"breadcrumbLarge\"") != None):
        source = searchForPlus(source, "class=\"breadcrumbLarge\"")
        source = searchForPlus(source, ">")
        i = string.find(source, "<")
        temp = stripText(source[0:i])

        if temp != "" and temp != "Books":
            if category != "":
                category = category + " : " + temp 
            else:
                category = temp


    # Find Title
    tag = "id=\"product_title\""
    source = searchForPlus(source, tag)
    source = searchForPlus(source, ">")
    i = string.find(source, "<")
    title = stripText(source[0:i])


    # Find Price
    tag = "class=\"productSpecialPrice\""
    i = string.find(source, tag)

    if i == -1:
        tag = "class=\"productOriginalPrice\""
        i = string.find(source, tag)

    if i != -1:
        val = searchForPlus(source, tag)
        val = searchFor(val, "$")
        i = string.find(val, "<")
        val = stripText(val[0:i])

        if val != "$0.00":
            value = val


    # Find Image
    tag = "<a href=\"http://assets."
    i = string.find(source, tag)

    if i == -1:
        tag = "<img src=\"http://assets."
        i = string.find(source, tag)

    if i != -1:
        image = searchFor(source, tag)
        image = searchForPlus(image, "\"")
        i = string.find(image, "\"")
        image = stripText(image[0:i])

        i = string.find(image, "no-image")

        if i != -1:
            image = ""


    # Find Rating
    i = string.find(source, ">Average Customer Rating<")

    if i != -1:
        rating = searchForPlus(source, ">Average Customer Rating<")
        rating = searchForPlus(rating, "stars_")
        i = string.find(rating, ".")
        rating = stripText(rating[0:i]) + " Stars"


    # Find Format
    i = string.find(source, ">Format:<")

    if i != -1:
        format = searchForPlus(source, ">Format:<")
        format = searchForPlus(format, "<td>")
        i = string.find(format, "<")
        format = stripText(format[0:i])

        i = string.find(format, ",")

        if i != -1:
            temp = stripText(format[i+1:])
            format = stripText(format[0:i])

            i = string.find(temp, " pages")

            if i != -1:
                pages = stripText(temp[0:i])


    # Find Author
    tag = "id=\"product_author\""
    i = string.find(source, tag)
    authorList = []

    if i != -1:
        source = searchFor(source, tag)

        i = string.find(source, "</table>")
        authors = stripText(source[0:i])

        while (searchFor(authors, "author=") != None):
            authors = searchForPlus(authors, "author=")
            authors = searchForPlus(authors, "\">")
            i = string.find(authors, "<")
            author = stripText(authors[0:i])
            author = convertAuthor(author)
            authorList.append(author)


        if len(authorList) > 0:
            author = authorList[0]

        if len(authorList) > 1:
            author2 = authorList[1]

        if len(authorList) > 2:
            author3 = authorList[2]

        if len(authorList) > 3:
            author4 = authorList[3]

        if len(authorList) > 4:
            author5 = authorList[4]

        if len(authorList) > 5:
            author6 = authorList[5]

    if title != "" and len(authorList) == 0:
        author = "No Author"


    # Find Publisher
    i = string.find(source, ">Publisher:")

    if i != -1:
        publisher = searchForPlus(source, ">Publisher:")
        publisher = searchForPlus(publisher, "<td>")

        if publisher.startswith("<a") == 1:
            publisher = searchForPlus(publisher, "\">")

        i = string.find(publisher, "<")
        publisher = stripText(publisher[0:i])

        i = string.find(publisher, ",")

        if i != -1:
            date = stripText(publisher[i+1:])
            publisher = stripText(publisher[0:i])

            if fullDateFormat == "false":
                i = string.rfind(date, " ")

                if i != -1:
                    date = stripText(date[i+1:])


    # Find ISBN
    i = string.find(source, ">ISBN:<")

    if i != -1:
        isbn = searchForPlus(source, ">ISBN:<")
        isbn = searchForPlus(isbn, "<td>")
        i = string.find(isbn, "<")
        isbn = stripText(isbn[0:i])


    # Find Dimensions
    i = string.find(source, ">Dimensions:")

    if i != -1:
        dimensions = searchForPlus(source, ">Dimensions:")
        dimensions = searchForPlus(dimensions, "<td>")
        i = string.find(dimensions, "<")
        dimensions = stripText(dimensions[0:i])

        i = string.find(dimensions, "(")

        if i != -1:
            dimensions = stripText(dimensions[0:i])


    # Find Place
    i = string.find(source, ">Published In:")

    if i != -1:
        place = searchForPlus(source, ">Published In:")
        place = searchForPlus(place, "<td>")
        i = string.find(place, "<")
        place = stripText(place[0:i])

        i = string.find(place, ",")

        if i != -1:
            date = stripText(place[i+1:])
            place = stripText(place[0:i])

            if fullDateFormat == "false":
                i = string.rfind(date, " ")

                if i != -1:
                    date = stripText(date[i+1:])


    # Find Comments
    tag = "<table class=\"product_info_text\"><tr><td><p>"
    i = string.find(source, tag)

    if i != -1 and i < 5000:
        comments = searchForPlus(source, tag)
        i = string.find(comments, "</td>")
        comments = stripText(comments[0:i])

        while (searchFor(comments, "\n") != None):
            i = string.find(comments, "\n")
            comments = comments[0:i] + comments[i+1:]

        i = string.find(comments, "<hr>This title is currently unavailable for purchase")

        if i != -1:
            comments = stripText(comments[0:i])

        i = string.find(comments, "<font")

        if i != -1:
            comments = stripText(comments[0:i])

        while (searchFor(comments, "\n") != None):
            i = string.find(comments, "\n")
            comments = comments[0:i] + comments[i+1:]

        comments = string.replace(comments, "\n\n\n", "\n\n")
        comments = string.replace(comments, "\n\n\n", "\n\n")
        comments = string.replace(comments, "<BR>", "\n")
        comments = string.replace(comments, "<br>", "\n")
        comments = string.replace(comments, "<p>", "\n\n")
        comments = string.replace(comments, "</p>", "")
        comments = string.replace(comments, "<P>", "\n\n")
        comments = string.replace(comments, "</P>", "")
        comments = string.replace(comments, "<b>", "")
        comments = string.replace(comments, "</b>", "")
        comments = string.replace(comments, "<B>", "")
        comments = string.replace(comments, "</B>", "")
        comments = string.replace(comments, "<i>", "")
        comments = string.replace(comments, "</i>", "")
        comments = string.replace(comments, "<I>", "")
        comments = string.replace(comments, "</I>", "")
        comments = string.replace(comments, "&#8211;", "-")
        comments = string.replace(comments, "&#8220;", "\"")
        comments = string.replace(comments, "&#8221;", "\"")
        comments = string.replace(comments, "&#8217;", "'")
        comments = string.replace(comments, "&#8230;", "...")
        comments = string.replace(comments, "</a>", "")
        comments = string.replace(comments, "</span>", "")

        while (searchFor(comments, "<a ") != None):
            i = string.find(comments, "<a ")
            j = string.find(comments[i:], ">")

            if j == -1:
                break;

            comments = comments[0:i] + comments[i+j+1:]

        while (searchFor(comments, "<img src=") != None):
            i = string.find(comments, "<img src=")
            j = string.find(comments[i:], ">")

            if j == -1:
                break;

            comments = comments[0:i] + comments[i+j+1:]

        while (searchFor(comments, "<span ") != None):
            i = string.find(comments, "<span ")
            j = string.find(comments[i:], ">")

            if j == -1:
                break;

            comments = comments[0:i] + comments[i+j+1:]

        while (searchFor(comments, "\n ") != None):
            i = string.find(comments, "\n ")
            comments = comments[0:i+1] + comments[i+2:]



# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*

try:
    extract()
finally:
    if os.path.exists("scrapers/userexit.py"):
        execfile("scrapers/userexit.py") in globals()
