# The National Bibliography of Finland scraper
#
# Copyright  1999-2009 Readerware Corporation.  All Rights Reserved.

import  os
import  string

from    com.readerware.http import HTTPConnection

from    scrapers.scrapers import convertAuthor
from    scrapers.scrapers import searchFor
from    scrapers.scrapers import searchForPlus
from    scrapers.scrapers import stripText
from    scrapers.scrapers import stripHTML
from    scrapers.scrapers import stripNewLines


def extract():
    global title,author,isbn,publisher,format,first,signed,date,place
    global copies,rating,condition,category,read,pflag,eflag,value
    global comments,dateEntered,dataSource,cart,ordered
    global lccn,dewey,userNumber,copyDate,valueDate,location
    global series,pages,keywords,dimensions
    global user1,user2,user3,user4,user5,user6,user7,user8,user9,user10
    global author2,author3,author4,author5,author6
    global usedprice,usedcount,collectibleprice,collectiblecount
    global newprice,newcount,listprice,readinglevel,salesrank,available
    global buyerwaiting,editionNumber,weight,image
    global fullDateFormat,source
    global callnumber


    # Defaults
    first               = "N"
    signed              = "N"
    read                = "N"
    pflag               = "Y"
    eflag               = "Y"
    ordered             = "N"
    usedprice           = ""
    usedcount           = ""
    collectibleprice    = ""
    collectiblecount    = ""
    newprice            = ""
    newcount            = ""
    listprice           = ""
    readinglevel        = ""
    salesrank           = ""
    available           = "Y"
    buyerwaiting        = "N"
    weight              = ""
    comments            =""


    # No place extraction default to US
    # place = "United States"


    # Find optional fields, pricing info etc.
    marketinfo = source


    # Main extraction
    # Find Author
    authorList = []
    i = string.find(source, ">Author(s):<")

    if i != -1:
        source = searchFor(source, ">Author(s):<")
        i = string.find(source, "</TR>")
        authors = stripText(source[0:i])

        while (searchFor(authors, "HREF=\"") != None):
            authors = searchForPlus(authors, "HREF=\"")
            authors = searchForPlus(authors, "\">")
            i = string.find(authors, "<")
            author = stripText(authors[0:i])
            i = string.rfind(author, "-")

            if i != -1:
                i = string.rfind(author, ",")
                author = stripText(author[0:i])

            authorList.append(author)

    i = string.find(source, ">Other Author(s):<")

    if i != -1:
        authors = searchFor(source, ">Other Author(s):<")
        i = string.find(authors, "</TR>")
        authors = stripText(authors[0:i])

        while (searchFor(authors, "HREF=\"") != None):
            authors = searchForPlus(authors, "HREF=\"")
            authors = searchForPlus(authors, "\">")
            i = string.find(authors, "<")
            author = stripText(authors[0:i])
            i = string.rfind(author, "-")

            if i != -1:
                i = string.rfind(author, ",")
                author = stripText(author[0:i])

            author = cleanupData(author)
            authorList.append(author)


    if len(authorList) > 0:
        author = authorList[0]

    if len(authorList) > 1:
        author2 = authorList[1]

    if len(authorList) > 2:
        author3 = authorList[2]

    if len(authorList) > 3:
        author4 = authorList[3]

    if len(authorList) > 4:
        author5 = authorList[4]

    if len(authorList) > 5:
        author6 = authorList[5]


    # Find Title
    source = searchForPlus(source, ">Title:<")
    source = searchForPlus(source, "HREF=\"")
    source = searchForPlus(source, "\">")
    i = string.find(source, "<")
    title = stripText(source[0:i])
    title = cleanupData(title)

    i = string.rfind(title, " / ")

    if i != -1:
        title = stripText(title[0:i])


    # Find Publisher
    i = string.find(source, ">Published:<")

    if i != -1:
        date = ""
        copyDate = ""
        publisher = searchForPlus(source, ">Published:<")
        publisher = searchForPlus(publisher, "<TD")
        publisher = searchForPlus(publisher, ">")
        i = string.find(publisher, "<")
        publisher = stripText(publisher[0:i])
        publisher = cleanupData(publisher)

        i = string.find(publisher, " : ")

        if i != -1:
            place = stripText(publisher[0:i])
            place = string.replace(place, "[", "")
            place = string.replace(place, "]", "")
            publisher = stripText(publisher[i+2:])

        i = string.find(publisher, ", ")

        if i != -1:
            date = stripText(publisher[i+1:])
            publisher = stripText(publisher[0:i])

            if date.startswith("cop.") == 1:
                copyDate = stripText(date[4:])
                date = "";

        i = string.find(date, " ")

        if i != -1:
            date = stripText(date[0:i])

        i = string.find(copyDate, " ")

        if i != -1:
            copyDate = stripText(copyDate[0:i])
            


    # Find Pages/Dimensions
    i = string.find(source, ">Material:<")

    if i != -1:
        attr = searchForPlus(source, ">Material:<")
        attr = searchForPlus(attr, "<TD")
        attr = searchForPlus(attr, ">")
        i = string.find(attr, "<")
        attr = stripText(attr[0:i])
        comment = "Physical description: " + attr

        if comments == "":
            comments = comment
        else:
            comments = comments + "\n\n" + comment

        i = string.find(attr, " s.")

        if i != -1:
            pages = stripText(attr[0:i])

        i = string.find(attr, " ; ")

        if i != -1:
            attr = stripText(attr[i+2:])

        i = string.find(attr, " cm")

        if i != -1:
            dimensions = stripText(attr[0:i+3])


    # Series
    i = string.find(source, ">Series:<")

    if i != -1:
        series = searchForPlus(source, ">Series:<")
        series = searchForPlus(series, "<TD")
        series = searchForPlus(series, ">")
        i = string.find(series, "<")
        series = stripText(series[0:i])
        series = cleanupData(series)


    # Find Comments, part 2
    i = string.find(source, ">Original Title:<")

    if i != -1:
        comment = searchForPlus(source, ">Original Title:<")
        comment = searchForPlus(comment, "<TD")
        comment = searchForPlus(comment, ">")
        i = string.find(comment, "<")
        comment = stripText(comment[0:i])
        comment = "Original title: " + cleanupData(comment)

        if comments == "":
            comments = comment
        else:
            comments = comments + "\n\n" + comment


    # Find ISBN
    i = string.find(source, ">ISBN:<")

    if i != -1:
        isbn = searchForPlus(source, ">ISBN:<")
        isbn = searchForPlus(isbn, "\">")
        i = string.find(isbn, "<")
        isbn = stripText(isbn[0:i])

        i = string.find(isbn, "(nid.)")

        if i != -1:
            format = "Paperback"

        i = string.find(isbn, "(hft.)")

        if i != -1:
            format = "Paperback"

        i = string.find(isbn, "(sid.)")

        if i != -1:
            format = "Hardcover"

        i = string.find(isbn, "(inb.)")

        if i != -1:
            format = "Hardcover"

        i = string.find(isbn, "(")

        if i != -1:
            isbn = stripText(isbn[0:i])


    # Find Keywords
    i = string.find(source, ">Subject:<")

    if i != -1:
        keywords = ""
        temp = searchForPlus(source, ">Subject:<")
        i = string.find(temp, "<TH")
        temp = stripText(temp[0:i])

        while (searchFor(temp, "HREF=\"") != None):
            temp = searchForPlus(temp, "HREF=\"")
            temp = searchForPlus(temp, "\">")
            i = string.find(temp, "<")
            keyword = stripText(temp[0:i])
            keyword = cleanupData(keyword)

            i = string.find(keyword, "(")

            if i != -1:
                keyword = stripText(keyword[0:i])

            if keywords == "":
                keywords = keyword
                category = keyword
            else:
                keywords = keywords + ", " + keyword



def cleanupData(str):
    str = string.replace(str, "\xC3\x84", "\xC4")
    str = string.replace(str, "\xC3\x85", "\xC5")
    str = string.replace(str, "\xC3\x96", "\xD6")
    str = string.replace(str, "\xC3\xA4", "\xE4")
    str = string.replace(str, "\xC3\xA5", "\xE5")
    str = string.replace(str, "\xC3\xB6", "\xF6")
    str = string.replace(str, "\xC5\x8D", "\xF6")
    return str    




try:
    extract()
finally:
    if os.path.exists("scrapers/userexit.py"):
        execfile("scrapers/userexit.py") in globals()
