# proxis.be.scraper
# this one is funny. proxis operates in English, French and Dutch
# we will try to make it work in any langage.....
#

import  os
import  string

from    com.readerware.http import HTTPConnection

from    scrapers.scrapers import convertAuthor
from    scrapers.scrapers import searchFor
from    scrapers.scrapers import searchForPlus
from    scrapers.scrapers import stripText
from    scrapers.scrapers import stripHTML
from    scrapers.scrapers import stripNewLines
from    scrapers.scrapers import calcISBN13CheckDigit
from    scrapers.scrapers import calcISBN10CheckDigit



def translate_nl(str):
    str = string.replace (str, "Literatuur", "Literature")
    str = string.replace (str, "Literaire romans", "Literature")
    str = string.replace (str, "Vertaalde", "Translated")
    str = string.replace (str, "Romans", "Novels")
    str = string.replace (str, "Verhalen", "Stories")
    str = string.replace (str, "Recht", "Law")
    str = string.replace (str, "Computers & informatica", "IT")
    str = string.replace (str, "Geschiedeniswetenschappen", "History of Science")
    str = string.replace (str, "Geschiedenis", "History")
    str = string.replace (str, "Pocket", "Mass Market Paperback")
    str = string.replace (str, "Populaire pockets", "Popular Reading")
    return string.strip(str);


def translate_text(str):
    str = string.replace(str, "\xC2\xAE", "")
    str = string.replace(str, "\xC3\xA8", "")
    str = string.replace(str, "\xC3\xA9", "")
    str = string.replace(str, "\xC3\xAB", "")
    str = string.replace(str, "\xC3\xAD", "")
    str = string.replace(str, "\xC3\xAF", "")
    str = string.replace(str, "\xE2\x80\x93", "-")
    str = string.replace(str, "\xE2\x80\x98", "'")
    str = string.replace(str, "\xE2\x80\x99", "'")
    return string.strip(str);



def extract():
    global title,author,isbn,publisher,format,first,signed,date,place
    global copies,rating,condition,category,read,pflag,eflag,value
    global comments,dateEntered,dataSource,cart,ordered
    global lccn,dewey,userNumber,copyDate,valueDate,location
    global series,pages,keywords,dimensions
    global user1,user2,user3,user4,user5,user6,user7,user8,user9,user10
    global author2,author3,author4,author5,author6
    global usedprice,usedcount,collectibleprice,collectiblecount
    global newprice,newcount,listprice,readinglevel,salesrank,available
    global buyerwaiting,editionNumber,weight,image
    global fullDateFormat,source


    # Defaults
    first               = "N"
    signed              = "N"
    read                = "N"
    pflag               = "Y"
    eflag               = "Y"
    ordered             = "N"
    usedprice           = ""
    usedcount           = ""
    collectibleprice    = ""
    collectiblecount    = ""
    newprice            = ""
    newcount            = ""
    listprice           = ""
    readinglevel        = ""
    salesrank           = ""
    available           = "Y"
    buyerwaiting        = "N"
    weight              = ""


    # No place extraction default to US
    # place = "Netherlands"

   
    # Find optional fields, pricing info etc.
    marketinfo = source

    i = string.find(source, ">De zoekopdracht heeft geen resultaten opgeleverd.")

    if i != -1:
        # try search again with ISBN-13
        source = searchForPlus(source, ">Zoekresultaat voor:")
        i = string.find(source, " - ");
        isbn13 = stripText(source[0:i])

        if len(isbn13) == 10:
            isbn13 = "978" + isbn13[0:9]
            isbn13 = calcISBN13CheckDigit(isbn13)

            url = "http://www.proxis.be/BENL/Search/Index.aspx?search=" + isbn13 + "&shop=100001NL&SelRubricLevel1Id=100001NL"
            http = HTTPConnection()
            http.resetReferer();
            http.blockForLoad();
            source = http.getContents(url)
            t2 = open("trace2.html", "w")
            t2.write(source)
            t2.close()


    # is this the search page or the detail page?
    i = string.find (source, "Zoekresultaat voor:")

    if i != -1: 
        source = searchForPlus(source, "Zoekresultaat voor:")
        source = searchForPlus(source, "href=")
        source = searchForPlus(source, "\"")
        i = string.find(source, "\"")
        url = "http://www.proxis.be" + stripText(source[0:i]);

        http = HTTPConnection()
        http.resetReferer();
        http.blockForLoad();
        source = http.getContents(url)
        t2 = open("trace3.html", "w")
        t2.write(source)
        t2.close()

    #
    # this should be the product page
    #

    # Find Title
    tag = "class=\"iconeProductDetail\""
    source = searchForPlus(source, tag)

    if source == None:
        print "can't find TITLE"
        return

    source = searchForPlus(source, "/>")
    i = string.find(source, "<");
    title = stripText(source[0:i])
    title = translate_text(title)

    if title.endswith(" -") == 1:
        i = string.rfind(title, " -");
        title = stripText(title[0:i])


    # Find Author
    author = ""
    tag = "productDetail_repContributor"
    i = string.find(source, tag)

    if i != -1:
        authorList = []
        source = searchForPlus(source, tag)
        i = string.find(source, "</h3>");
        authors = stripText(source[0:i])

        while (searchFor(authors, "<span>") != None):
            authors = searchForPlus(authors, "<span>")
            i = string.find(authors, "<");
            author = stripText(authors[0:i])
            author = stripHTML(author)
            author = translate_text(author)
            authorList.append(author)

        if len(authorList) > 0:
            author = authorList[0]

        if len(authorList) > 1:
            author2 = authorList[1]

        if len(authorList) > 2:
            author3 = authorList[2]

        if len(authorList) > 3:
            author4 = authorList[3]

        if len(authorList) > 4:
            author5 = authorList[4]

        if len(authorList) > 5:
            author6 = authorList[5]


    if title != "" and author == "":
        author = "No Author"


    # Find Cover Image
    tag = "_imgProduct"
    i = string.find(source, tag)

    if i != -1:
        source = searchForPlus(source, tag)
        tag = " src=\""
        i = string.find(source, tag)

        if (i != -1 and i < 100):
            source = searchForPlus(source, tag)
            i = string.find(source, "\"")
            image = stripText(source[0:i])
        else:
            #print "i too big ", i
            image = "";
    # print "Image is ", image


    # Find value
    tag = "class=\"priceBig\""
    i = string.find(source, tag)

    if i != -1:
        source = searchForPlus(source, tag)
        source = searchForPlus(source, ">")
        i = string.find(source, " ")
        value = stripText(source[0:i])
        value = value + " "


    # Find Comments - usually in the language of the book - FR/EN/NL
    tag = "_pDescription"
    i = string.find(source, tag)

    if i != -1:
        source = searchForPlus(source, tag)
        source = searchForPlus(source, "\">")
        i = string.find(source, "</div>")
        comments = stripText(source[0:i])

        if comments.startswith("<div") == 1:
            comments = searchForPlus(comments, "\">")

        if comments.startswith("<span") == 1:
            comments = searchForPlus(comments, "\">")

        if comments.startswith("<BR><SPAN") == 1:
            comments = searchForPlus(comments, ">")
            comments = searchForPlus(comments, ">")

        comments = translate_text(comments)
        comments = string.replace(comments, "<BR>", "\n\n")
        comments = string.replace(comments, "<br>", "\n\n")
        comments = string.replace(comments, "<br/>", "\n\n")
        comments = string.replace(comments, "<p align=\"left\">", "\n\n")
        comments = string.replace(comments, "<p>", "\n\n")
        comments = string.replace(comments, "</p>", "\n\n")
        comments = string.replace(comments, "<b>", "")
        comments = string.replace(comments, "</b>", "")
        comments = string.replace(comments, "<i>", "")
        comments = string.replace(comments, "</i>", "")
        comments = string.replace(comments, "<em>", "")
        comments = string.replace(comments, "</em>", "")
        comments = string.replace(comments, "<strong>", "")
        comments = string.replace(comments, "</strong>", "")

        while (searchFor(comments, "\n ") != None):
            i = string.find(comments, "\n ")
            comments = comments[0:i+1] + comments[i+2:]

        while (searchFor(comments, "\n\n\n") != None):
            i = string.find(comments, "\n\n\n")
            comments = comments[0:i] + comments[i+2:]


    # Find Format
    i = string.find(source, ">Type<")

    if i != -1:
        format = searchForPlus(source, ">Type<")
        format = searchForPlus(format, "<td>")
        i = string.find(format, "<")
        format = stripText(format[0:i])
        format = translate_nl(format)


    # Find Category
    i = string.find(source, ">Categorie<")

    if i != -1:
        category = searchForPlus(source, ">Categorie<")
        category = searchForPlus(category, "<td>")

        if category.startswith("<a href=") == 1:
            category = searchForPlus(category, "\">")

        i = string.find(category, "<")
        category = stripText(category[0:i])


    # Find Publication date
    i = string.find(source, ">Verschijningsdatum<")

    if i != -1:
        date = searchForPlus(source, ">Verschijningsdatum<")
        date = searchForPlus(date, "<td>")
        i = string.find(date, "<")
        date = stripText(date[0:i])

        if date == "01/01/0001":
            date = ""

        if date != "":
            if fullDateFormat == "false":
                i = string.rfind(date, "/")

                if i != -1:
                    date = stripText(date[i+1:])


    # Find ISBN
    tag = ">ISBN<"
    i = string.find(source, tag)

    if i == -1:
        tag = ">Streepjescode (EAN)<"
        i = string.find(source, tag)

    if i != -1:
        isbn = searchForPlus(source, tag)
        isbn = searchForPlus(isbn, "<td>")
        i = string.find(isbn, "<")
        isbn = stripText(isbn[0:i])

        if isbn.startswith("978") == 1:
            isbn = isbn[3:]
            isbn = stripText(isbn[0:len(isbn)-1])
            isbn = calcISBN10CheckDigit(isbn)


    # Find Dimensions
    i = string.find(source, ">Formaat<")

    if i != -1:
        dimensions = searchForPlus(source, ">Formaat<")
        dimensions = searchForPlus(dimensions, "<td>")
        i = string.find(dimensions, "<")
        dimensions = stripText(dimensions[0:i])


    # Find page count
    i = string.find(source, ">Pagina's<")

    if i != -1:
        pages = searchForPlus(source, ">Pagina's<")
        pages = searchForPlus(pages, "<td>")
        i = string.find(pages, "<")
        pages = stripText(pages[0:i])


# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*


# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*


# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*
# *------------------------------------------------------------------------------------------------*



try:
    extract()
finally:
    if os.path.exists("scrapers/userexit.py"):
        execfile("scrapers/userexit.py") in globals()
